package com.sw.config;

import org.redisson.Redisson;
import org.redisson.api.RedissonClient;
import org.redisson.client.codec.StringCodec;
import org.redisson.config.Config;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.ClassPathResource;

import java.io.IOException;

/**
 * redisson 配置
 *
 * @author yegang
 * @create 2022-02-23 13:14
 **/
@Configuration
public class RedissonConfig {
    @Bean
    public RedissonClient configRedisson() throws IOException {
        Config config = Config.fromYAML(new ClassPathResource("redisson.yml").getInputStream());
        config.setCodec(new StringCodec());
//        config.setLockWatchdogTimeout(12000);
        RedissonClient redissonClient = Redisson.create(config);
        return redissonClient;

    }
}
