package com.sw;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.sw.dao.SysUserDao;
import com.sw.dao.TMaskDao;
import com.sw.dao.TOrderDao;
import com.sw.service.TMaskService;
import io.lettuce.core.SetArgs;
import io.lettuce.core.api.async.RedisAsyncCommands;
import io.lettuce.core.cluster.api.async.RedisAdvancedClusterAsyncCommands;
import org.junit.Assert;
import org.junit.Test;
import org.junit.jupiter.api.Order;
import org.junit.runner.RunWith;
import org.redisson.api.RedissonClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * @Description TODO
 * @Author DingLan
 * @Date 2022/2/18 10:29
 **/
@RunWith(SpringRunner.class)
@SpringBootTest
public class RedisTest {
    @Autowired
    private RedisTemplate redisTemplate;
    @Resource
    private TOrderDao tOrderDao;
    @Resource
    private TMaskService tMaskService;

    /**
     * 初始化合法用户uid 到redis
     */
    @Test
    @Order(2)
    public void addSetTest(){
        List<Integer> uids = new ArrayList<>();
        for (int i = 0;i < 1000; i++){
            uids.add( i + 1);
        }
        redisTemplate.opsForSet().add("userUids", uids.toArray());
        Assert.assertEquals(1000l, redisTemplate.opsForSet().size("userUids").longValue());
    }

    @Test
    @Order(1)
    public void clear(){
        Long count = redisTemplate.opsForSet().size("userUids");
        System.out.println(count);
        redisTemplate.opsForSet().pop("userUids", count);

    }

    @Test
    public void  isMember(){
//        System.out.println(redisTemplate.opsForSet().isMember("userUid", "18"));
//        System.out.println(redisTemplate.opsForSet().isMember("userUid", 18));
        System.out.println(redisTemplate.opsForSet().isMember("successUserUids", 18));
    }

    @Test
    public void addMas(){
        redisTemplate.opsForHash().put("usableMasks", "mask-1", 100);
        redisTemplate.opsForHash().put("usableMasks", "mask-2", 100);

//        System.out.printf("res: "  + redisTemplate.opsForHash().get("usableMasks", "mask-1").toString());

    }
    @Test
    public void decr(){
//        Long res = redisTemplate.opsForHash().increment("usableMasks", "mask-1", -5l);
//        System.out.println(res);
        byte[] key = redisTemplate.getKeySerializer().serialize("mask-setnx-mq");
        byte[] value = redisTemplate.getValueSerializer().serialize(1);

        Boolean res = redisTemplate.getConnectionFactory().getConnection().setNX(key, value);
        System.out.println(res);
//        //lettuce连接下 redis单机setnx
//        if(nativeConnection instanceof RedisAsyncCommands){
//            RedisAsyncCommands commands = (RedisAsyncCommands) nativeConnection;
//            String res = commands.getStatefulConnection().sync()
//                    .set(key, value, SetArgs.Builder.nx().ex(10));
//            System.out.println(res);
//        }
//        if(nativeConnection instanceof RedissonClient){
//            RedisAsyncCommands commands = (RedisAsyncCommands) nativeConnection;
//            String res = commands.getStatefulConnection().sync()
//                    .set(key, value, SetArgs.Builder.nx().ex(10));
//            System.out.println(res);
//        }
//        //lettuce连接下 redis集群setnx
//        if(nativeConnection instanceof RedisAdvancedClusterAsyncCommands){
//            RedisAdvancedClusterAsyncCommands commands = (RedisAdvancedClusterAsyncCommands) nativeConnection;
//            String res = commands.getStatefulConnection().sync()
//                    .set(key, value, SetArgs.Builder.nx().ex(10));
//            System.out.println(res);
//        }
//        racac.getStatefulConnection().async().setnx("")
//        redisTemplate.opsForValue().set("remain", 100);
    }

    @Test
    public void delete(){
        redisTemplate.delete("successUserUids");
        redisTemplate.opsForHash().put("usableMasks", "mask-1", 100);
        redisTemplate.opsForHash().put("usableMasks", "mask-2", 100);

        UpdateWrapper updateWrapper = new UpdateWrapper();
        updateWrapper.setSql(" mask_stock =100 ");
        tMaskService.update(updateWrapper);

        tOrderDao.delete(new UpdateWrapper<>());

    }
}
